/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Mozilla Communicator client code, released
 * March 31, 1998.
 * 
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation. Portions created by Netscape are
 * Copyright (C) 1998-1999 Netscape Communications Corporation. All
 * Rights Reserved.
 */

/* This is where functions related to the quick reply box live. */

/**
 * interfaces
 */
var nsIMsgCompDeliverMode = Components.interfaces.nsIMsgCompDeliverMode;
var nsIMsgCompSendFormat = Components.interfaces.nsIMsgCompSendFormat;
var nsIMsgCompConvertible = Components.interfaces.nsIMsgCompConvertible;
var nsIMsgCompType = Components.interfaces.nsIMsgCompType;
var nsIMsgCompFormat = Components.interfaces.nsIMsgCompFormat;
var nsIAbPreferMailFormat = Components.interfaces.nsIAbPreferMailFormat;
var nsIPlaintextEditorMail = Components.interfaces.nsIPlaintextEditor;

/**
 * static globals, need to be initialized only once
 */
var sMsgComposeService = Components.classes["@mozilla.org/messengercompose;1"].getService(Components.interfaces.nsIMsgComposeService);

var sPrefs = null;
var sPrefBranchInternal = null;
var sOther_headers = "";

var sAccountManagerDataSource = null;
var sRDF = null;
var sNameProperty = null;

var sQuickReplyMessagesBundle = document.getElementById("bundle_quickreplyMessages");

// shortcut key for focus
function setFocusToQRTextInput(tgt) {
	var viewQuickReplyToolbar;
	try {
			viewQuickReplyToolbar = pref.getBoolPref( 'quickreply.display_' + tgt );
	} catch (e) {
			viewQuickReplyToolbar = 1;
	}
	if(viewQuickReplyToolbar) {
		document.getElementById('quickReplyInput').focus();
	}
}

// menu item
function initQRMenuItem(tgt) {
	var viewQuickReplyToolbar;
	try {
			viewQuickReplyToolbar = pref.getBoolPref('quickreply.display_' + tgt);
	} catch (e) {
			viewQuickReplyToolbar = 1;
			pref.setBoolPref( 'quickreply.display_' + tgt, viewQuickReplyToolbar );
	}
	document.getElementById('menu_showQuickReplyToolbar').setAttribute("checked", viewQuickReplyToolbar ? "true" : "false");
}

function toggleQuickReplyMenuItem(tgt) {
	var viewQuickReplyToolbar;
	try {
			viewQuickReplyToolbar = pref.getBoolPref( 'quickreply.display_' + tgt );
	} catch (e) {
			viewQuickReplyToolbar = 0;
	}
	viewQuickReplyToolbar = 1-viewQuickReplyToolbar;
	if(viewQuickReplyToolbar) {
			document.getElementById('menu_showQuickReplyToolbar').setAttribute("checked", "true");
			ShowQuickReplyBox(tgt);
	} else {
			document.getElementById('menu_showQuickReplyToolbar').setAttribute("checked", "false");
			HideQuickReplyBox(tgt);
	}
	pref.setBoolPref( 'quickreply.display_' + tgt, viewQuickReplyToolbar );
}

/** Stuff connected to the interface */
function getCurrentIdentity() {
	return accountManager.getFirstIdentityForServer(GetLoadedMsgFolder().server);
}

function setStatus(newStatus) {
	document.getElementById("statusText").setAttribute("label", newStatus);
}

function ShowQuickReplyBox(tgt) {
	var QRBox = document.getElementById( 'msgQuickReply_' + tgt);
	if (QRBox)
			QRBox.collapsed = false;
} 

function HideQuickReplyBox(tgt) { 
	var QRBox = document.getElementById( 'msgQuickReply_' + tgt);
	if (QRBox)
			QRBox.collapsed = true;
}

function disableQR() {
	document.getElementById("sendButton").disabled=true;
	document.getElementById("quickReplyInput").disabled=true;
}

function enableQR() {
	document.getElementById("sendButton").disabled=false;
	document.getElementById("quickReplyInput").disabled=false;
}

function clearQR() {
	try {
		if( pref.getBoolPref( 'quickreply.deleteaftersend') )
			document.getElementById("quickReplyInput").value="";
	} catch(e) {
		document.getElementById("quickReplyInput").value="";
	}
}

function doQRTextBoxFocus(e) {
//	var tb = document.getElementById('quickReplyInput');
	setStatus('tb focus '+e.type);
}

function doQRTextBoxClick(e) {
	alert('boeh');
//	var tb = document.getElementById('quickReplyInput');
//	if(!tb.focussed) tb.select();
}

function doQRTextBoxKeyPress(e) {
//	setStatus(e.type+"|ctrl:"+e.ctrlKey+"|alt:"+e.altKey+"|keyCode:"+e.keyCode+"|charCode:"+e.charCode+"|which:"+e.which);
	if(e.ctrlKey == true && e.altKey == false && e.metaKey == false && e.which== 13 ) { // Enter: 13
		// ctrl+enter --> send; check if that's ok.
		disableQR();
		if( !maybeWarnOnSend() ) {
			enableQR();
			return;
		}
		doQuickReply(e);	// just pass the same event - saves the hassle.
	} else if(e.ctrlKey == false && e.altKey == false && e.metaKey == false && e.keyCode == 9) {
		// tab: insert tab character.
		e.preventDefault();
		var textbox = document.getElementById("quickReplyInput")
		var content = textbox.value;
		var selStart = textbox.selectionStart;
		var selEnd = textbox.selectionEnd;
		textbox.value = content.substr(0, selStart )+"\t"+content.substr(selEnd, content.length );
		textbox.setSelectionRange( selStart+1, selStart+1);
	}
}

/** function doQuickReply
	*	This is the callback of the QuickReply button.
	*/
function doQuickReply(e) {
	if (document.getElementById("quickReplyInput").value == null ||
			document.getElementById("quickReplyInput").value == "")	{
			return;
	}
	
	var srcMsgHdr, tgt;
	disableQR();
	var srcMsgURI = GetLoadedMessage();
	try {
			srcMsgHdr = messenger.messageServiceFromURI(srcMsgURI).messageURIToMsgHdr(srcMsgURI)//GetMsgHdrFromUri(srcMsgURI);
	} catch (ex) {
			enableQR();
			return;
	}
	var srcMsgId = srcMsgHdr.messageId;
	var subj = srcMsgHdr.subject; //currentHeaderData["subject"].headerValue;

	// dwlt: is this localized in the main Mozilla app? If so, is there a way to request this value?
	//		::can't find it in the main components anywhere, but haven't looked in the C++ source base
	//		::if we can't find it there, we should just put in the quickreply.properties file
	
	if( subj.substring(0,4).toLowerCase() != "re: " ) {
			subj = "Re: " + subj;
	}
	if ('reply-to' in currentHeaderData)
			tgt = currentHeaderData['reply-to'].headerValue;
	else
			tgt = srcMsgHdr.author;
	doReply( e.shiftKey == false, tgt, subj, document.getElementById("quickReplyInput").value, srcMsgId );
}

// Check mail.warn_on_send_accel_key, and if necessary, ask for confirmation.
// Returns true if it's OK to send, false if not.
function maybeWarnOnSend() {
    var warn = pref.getBoolPref("mail.warn_on_send_accel_key");
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    var composeMsgsBundle = document.getElementById("bundle_composeMsgs");

    if (warn) {
        var checkValue = {value:false};
        var buttonPressed = promptService.confirmEx(window, 
              composeMsgsBundle.getString('sendMessageCheckWindowTitle'), 
              composeMsgsBundle.getString('sendMessageCheckLabel'),
              (promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0) +
              (promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1),
              composeMsgsBundle.getString('sendMessageCheckSendButtonLabel'),
              null, null,
              composeMsgsBundle.getString('CheckMsg'), 
              checkValue);
        if (buttonPressed != 0) {
            return false;
        }
        if (checkValue.value) {
            pref.setBoolPref("mail.warn_on_send_accel_key", false);
        }
    }
    return true;
}

/** Under-the-hood stuff */
function onSMIMEStartHeadersQuickReply() {
}

function onSMIMEEndHeadersQuickReply() {
	ShowQuickReplyBox();
	document.getElementById("QuickReplyTarget").value = currentHeaderData["to"].headerValue ;
}

function regListeners() {
	var listener = {};
	listener.onStartHeaders = onSMIMEStartHeadersQuickReply;
	listener.onEndHeaders = onSMIMEEndHeadersQuickReply;
	gMessageListeners.push(listener);
}

function QRMessagePaneOnLoad() {
// window.setTimeout("regListeners()", 1000);
	regListeners();
}

function QRMessagePaneOnUnload() {
}

addEventListener("messagepane-loaded", QRMessagePaneOnLoad, true);
addEventListener("messagepane-unloaded", QRMessagePaneOnUnload, true);

// all progress notifications are done through the nsIWebProgressListener implementation...
var progressListener = {
	onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
				if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_START) {
//					setStatus( sQuickReplyMessagesBundle.getString('statusStartingSend') );
						setStatus( document.getElementById("bundle_quickreplyMessages").getString('statusStartingSend') );
				}
				if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
						clearQR();
						enableQR();
//					setStatus( sQuickReplyMessagesBundle.getString('statusMessageSent') );
						setStatus( document.getElementById("bundle_quickreplyMessages").getString('statusMessageSent') );
						window.setTimeout("setStatus('')", "3000");
			}
	},
	
	// could implement progress bar using aCurTotalProgress/aMaxTotalProgress
	onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
				var perc = Math.round(aCurTotalProgress * 100/aMaxTotalProgress);
//			setStatus( sQuickReplyMessagesBundle.getString('statusMessageSending')+" "+perc+"%");
				setStatus( document.getElementById("bundle_quickreplyMessages").getString('statusMessageSending') + ' ' + perc + '%' );
	},

	onLocationChange: function(aWebProgress, aRequest, aLocation)
	{},

	onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {
				// Looks like it's possible that we get call while the document has been already delete!
				// therefore we need to protect ourself by using try/catch
				try {
						setStatus( aMessage );
						if(aMessage == "Copy complete." ) { // XX dirty hack! Otherwise, the message lingers. -- won't localise, either!
							window.setTimeout("setStatus('');clearQR();enableQR();", "3000");
						}
				} catch (ex) {};
	},

	onSecurityChange: function(aWebProgress, aRequest, state)
	{},

	QueryInterface : function(iid)
	{
			if (iid.equals(Components.interfaces.nsIWebProgressListener) ||
						iid.equals(Components.interfaces.nsISupportsWeakReference) ||
						iid.equals(Components.interfaces.nsISupports))
				return this;
			
			throw Components.results.NS_NOINTERFACE;
	}
};

function doReplyFailed( why, content ) {
	if(why) { dump(why); }
	setStatus( why );
	setTimeout( "setStatus('')", 10000 );
	if( content.length > 0 ) {
		document.getElementById("quickReplyInput").value = content;
	}
	enableQR();
	return false;
}

// the actual sending function.
function doReply( sendNow, to, sbj, bdy, srcId ) {

	// set references & in-reply-to
	var compfields = Components.classes["@mozilla.org/messengercompose/composefields;1"].createInstance(Components.interfaces.nsIMsgCompFields);
	if(!compfields) {
//			return doReplyFailed(sQuickReplyMessagesBundle.getString('failCompFields') /*"Failed to initialise compfields for quick reply."*/);
				return doReplyFailed(document
						.getElementById("bundle_quickreplyMessages")
						.getString('failCompFields'),
						bdy
						/*"Failed to initialise compfields for quick reply."*/);
	}
	var msgCompose = Components.classes["@mozilla.org/messengercompose/compose;1"].createInstance(Components.interfaces.nsIMsgCompose);
	if(!msgCompose) {
//			return doReplyFailed(sQuickReplyMessagesBundle.getString('failMsgCompose') /*"Failed to initialise msgCompose for quick reply."*/);
				return doReplyFailed(document.getElementById("bundle_quickreplyMessages").getString('failMsgCompose') /*"Failed to initialise compfields for quick reply."*/);
	}
	var params = Components.classes["@mozilla.org/messengercompose/composeparams;1"].createInstance(Components.interfaces.nsIMsgComposeParams);
	if(!params) {
//			return doReplyFailed(sQuickReplyMessagesBundle.getString('failInitParams') /*"Failed to initialise params for quick reply."*/);
				return doReplyFailed(document
						.getElementById("bundle_quickreplyMessages")
						.getString('failInitParams'),
						bdy
						/*"Failed to initialise compfields for quick reply."*/);
	}
	var progress = Components.classes["@mozilla.org/messenger/progress;1"].createInstance(Components.interfaces.nsIMsgProgress);
	if(!progress) {
//			return doReplyFailed(sQuickReplyMessagesBundle.getString('failInitProgress') /*"Failed to initialise progress for quick reply."*/);
				return doReplyFailed(document
						.getElementById("bundle_quickreplyMessages")
						.getString('failInitProgress'),
						bdy
						/*"Failed to initialise compfields for quick reply."*/);
	}
				progress.registerListener(progressListener);


	compfields.to = to;
	compfields.subject = sbj
	compfields.body = bdy;
	compfields.references = "<"+srcId+">";
//	compfields.forcePlainText = true;
//	alert('body'+compfields.body);

	params.composeFields = compfields;
	params.format = 2;	// PlainText, otherwise we loose our formatting!
	msgCompose.Initialize(null, params );
	try {
		if( sendNow ) {
			msgCompose.SendMsg(nsIMsgCompDeliverMode.Now, getCurrentIdentity(), progress);
		} else {
			msgCompose.SendMsg(nsIMsgCompDeliverMode.Later, getCurrentIdentity(), progress);
		}
	} catch(ex) {
		return doReplyFailed(document
				.getElementById("bundle_quickreplyMessages")
				.getString('failMsgSend'),
				bdy);
	}
}
